package jpa.test.entities;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.MapKeyJoinColumn;

@Entity
public class DocumentVersion {

	private Long id;
	private Document document;
	private Map<Person, Template> templatesByOwner = new HashMap<>();
	
	@Id
	@Column(name = "DOCUMENT_VERSION_ID")
	@GeneratedValue
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	
	@ManyToOne(fetch = FetchType.LAZY, optional = false)
	public Document getDocument() {
		return document;
	}
	public void setDocument(Document document) {
		this.document = document;
	}
	
	@ManyToMany
    @MapKeyJoinColumn(unique = true, nullable=false)
	public Map<Person, Template> getTemplatesByOwner() {
		return templatesByOwner;
	}
	
	public void setTemplatesByOwner(Map<Person, Template> templatesByOwner) {
		this.templatesByOwner = templatesByOwner;
	}
}
